﻿using ProjectMotorboat.Entities;

namespace ProjectMotorboat.Drownings;
public static class ExtentionDrawningBoat
{
    private static readonly string _separatorForObject = ":";
    public static DrawningBoat? CreateDrawningBoat(this string info)
    {
        string[] strs = info.Split(_separatorForObject);
        EntityBoat? boat = EntityMotorboat.CreateEntityMotorboat(strs);
        if (boat != null)
        {
            return new DrawningMotorboat((EntityMotorboat)boat);
        }

        boat = EntityBoat.CreateEntityBoat(strs);
        if (boat != null)
        {
            return new DrawningBoat(boat);
        }
        return null;
    }
    public static string GetDataForSave(this DrawningBoat drawningBoat)
    {
        string[]? array = drawningBoat?.EntityBoat?.GetStringRepresentation();

        if (array == null)
        {
            return string.Empty;
        }

        return string.Join(_separatorForObject, array);
    }
}
