﻿namespace ProjectMotorboat.Entities;

public class EntityBoat
{
    public int Speed { get; private set; }

    public double Weight { get; private set; }

    public Color BodyColor { get; private set; }

    public void SetBodyColor(Color color)
    {
        BodyColor = color;
    }
    public double Step => Speed * 100 / Weight;

    public EntityBoat(int speed, double weight, Color bodyColor)
    {
        Speed = speed;
        Weight = weight;
        BodyColor = bodyColor;
    }
    public virtual string[] GetStringRepresentation()
    {
        return new[] { nameof(EntityBoat), Speed.ToString(), Weight.ToString(), BodyColor.Name };
    }
    public static EntityBoat? CreateEntityBoat(string[] strs)
    {
        if (strs.Length != 4 || strs[0] != nameof(EntityBoat))
        {
            return null;
        }

        return new EntityBoat(Convert.ToInt32(strs[1]), Convert.ToDouble(strs[2]), Color.FromName(strs[3]));
    }
}
